]> git.ipfire.org Git - thirdparty/git.git/blame - git-filter-branch.sh
unquote_c_style: fix off-by-one.
[thirdparty/git.git] / git-filter-branch.sh
CommitLineData
6f6826c5
JS
1#!/bin/sh
2#
3# Rewrite revision history
4# Copyright (c) Petr Baudis, 2006
5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
6#
c401b33c
JS
7# Lets you rewrite the revision history of the current branch, creating
8# a new branch. You can specify a number of filters to modify the commits,
9# files and trees.
6f6826c5 10
16ed34ad
JS
11# The following functions will also be available in the commit filter:
12
13functions=$(cat << \EOF
b5669a05
SP
14warn () {
15 echo "$*" >&2
16}
17
6f6826c5
JS
18map()
19{
3520e1e8 20 # if it was not rewritten, take the original
c57a3494
JS
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
26 fi
6f6826c5
JS
27}
28
f95eef15
JS
29# if you run 'skip_commit "$@"' in a commit filter, it will print
30# the (mapped) parents, effectively skipping the commit.
31
32skip_commit()
33{
34 shift;
35 while [ -n "$1" ];
36 do
37 shift;
38 map "$1";
39 shift;
40 done;
41}
42
8c1ce0f4
JS
43# override die(): this version puts in an extra line break, so that
44# the progress is still visible
45
46die()
47{
48 echo >&2
49 echo "$*" >&2
50 exit 1
51}
16ed34ad
JS
52EOF
53)
54
55eval "$functions"
8c1ce0f4 56
6f6826c5
JS
57# When piped a commit, output a script to set the ident of either
58# "author" or "committer
59
60set_ident () {
61 lid="$(echo "$1" | tr "A-Z" "a-z")"
62 uid="$(echo "$1" | tr "a-z" "A-Z")"
63 pick_id_script='
64 /^'$lid' /{
65 s/'\''/'\''\\'\'\''/g
66 h
67 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
68 s/'\''/'\''\'\'\''/g
3addc94a 69 s/.*/GIT_'$uid'_NAME='\''&'\''; export GIT_'$uid'_NAME/p
6f6826c5
JS
70
71 g
72 s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
73 s/'\''/'\''\'\'\''/g
3addc94a 74 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
6f6826c5
JS
75
76 g
77 s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
78 s/'\''/'\''\'\'\''/g
3addc94a 79 s/.*/GIT_'$uid'_DATE='\''&'\''; export GIT_'$uid'_DATE/p
6f6826c5
JS
80
81 q
82 }
83 '
84
85 LANG=C LC_ALL=C sed -ne "$pick_id_script"
86 # Ensure non-empty id name.
3addc94a 87 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
6f6826c5
JS
88}
89
7e0f1704
JS
90USAGE="[--env-filter <command>] [--tree-filter <command>] \
91[--index-filter <command>] [--parent-filter <command>] \
92[--msg-filter <command>] [--commit-filter <command>] \
93[--tag-name-filter <command>] [--subdirectory-filter <directory>] \
94[--original <namespace>] [-d <directory>] [-f | --force] \
bb8eebb9 95[<rev-list options>...]"
7e0f1704 96
8f321a39 97OPTIONS_SPEC=
7e0f1704
JS
98. git-sh-setup
99
46eb449c 100git diff-files --quiet &&
38762c47 101 git diff-index --cached --quiet HEAD -- ||
46eb449c
JS
102 die "Cannot rewrite branch(es) with a dirty working directory."
103
6f6826c5 104tempdir=.git-rewrite
6f6826c5
JS
105filter_env=
106filter_tree=
107filter_index=
108filter_parent=
109filter_msg=cat
5be60078 110filter_commit='git commit-tree "$@"'
6f6826c5 111filter_tag_name=
685ef546 112filter_subdir=
dfd05e38
JS
113orig_namespace=refs/original/
114force=
822f7c73 115while :
6f6826c5
JS
116do
117 case "$1" in
118 --)
119 shift
120 break
121 ;;
dfd05e38
JS
122 --force|-f)
123 shift
124 force=t
125 continue
126 ;;
6f6826c5
JS
127 -*)
128 ;;
129 *)
130 break;
131 esac
132
133 # all switches take one argument
134 ARG="$1"
135 case "$#" in 1) usage ;; esac
136 shift
137 OPTARG="$1"
138 shift
139
140 case "$ARG" in
141 -d)
142 tempdir="$OPTARG"
143 ;;
6f6826c5
JS
144 --env-filter)
145 filter_env="$OPTARG"
146 ;;
147 --tree-filter)
148 filter_tree="$OPTARG"
149 ;;
150 --index-filter)
151 filter_index="$OPTARG"
152 ;;
153 --parent-filter)
154 filter_parent="$OPTARG"
155 ;;
156 --msg-filter)
157 filter_msg="$OPTARG"
158 ;;
159 --commit-filter)
16ed34ad 160 filter_commit="$functions; $OPTARG"
6f6826c5
JS
161 ;;
162 --tag-name-filter)
163 filter_tag_name="$OPTARG"
164 ;;
685ef546
JS
165 --subdirectory-filter)
166 filter_subdir="$OPTARG"
167 ;;
dfd05e38 168 --original)
55ced83d 169 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
dfd05e38 170 ;;
6f6826c5
JS
171 *)
172 usage
173 ;;
174 esac
175done
176
dfd05e38
JS
177case "$force" in
178t)
179 rm -rf "$tempdir"
180;;
181'')
182 test -d "$tempdir" &&
183 die "$tempdir already exists, please remove it"
184esac
af580e9c 185mkdir -p "$tempdir/t" &&
dfd05e38 186tempdir="$(cd "$tempdir"; pwd)" &&
af580e9c
JS
187cd "$tempdir/t" &&
188workdir="$(pwd)" ||
189die ""
6f6826c5 190
def16e71
BC
191# Remove tempdir on exit
192trap 'cd ../..; rm -rf "$tempdir"' 0
193
dfd05e38
JS
194# Make sure refs/original is empty
195git for-each-ref > "$tempdir"/backup-refs
196while read sha1 type name
197do
198 case "$force,$name" in
199 ,$orig_namespace*)
200 die "Namespace $orig_namespace not empty"
201 ;;
202 t,$orig_namespace*)
203 git update-ref -d "$name" $sha1
204 ;;
205 esac
206done < "$tempdir"/backup-refs
207
46eb449c
JS
208ORIG_GIT_DIR="$GIT_DIR"
209ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
210ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
3addc94a
JS
211GIT_WORK_TREE=.
212export GIT_DIR GIT_WORK_TREE
6f6826c5 213
418fa3a5 214# The refs should be updated if their heads were rewritten
0f047f3b 215git rev-parse --no-flags --revs-only --symbolic-full-name --default HEAD "$@" |
418fa3a5 216sed -e '/^^/d' >"$tempdir"/heads
dfd05e38
JS
217
218test -s "$tempdir"/heads ||
219 die "Which ref do you want to rewrite?"
220
3addc94a
JS
221GIT_INDEX_FILE="$(pwd)/../index"
222export GIT_INDEX_FILE
af580e9c 223git read-tree || die "Could not seed the index"
6f6826c5
JS
224
225ret=0
226
af580e9c
JS
227# map old->new commit ids for rewriting parents
228mkdir ../map || die "Could not create map/ directory"
6f6826c5 229
685ef546
JS
230case "$filter_subdir" in
231"")
5be60078 232 git rev-list --reverse --topo-order --default HEAD \
813b4734 233 --parents "$@"
685ef546
JS
234 ;;
235*)
5be60078 236 git rev-list --reverse --topo-order --default HEAD \
cfabd6ee 237 --parents --full-history "$@" -- "$filter_subdir"
af580e9c 238esac > ../revs || die "Could not get the commits"
9d6f220c 239commits=$(wc -l <../revs | tr -d " ")
6f6826c5
JS
240
241test $commits -eq 0 && die "Found nothing to rewrite"
242
dfd05e38
JS
243# Rewrite the commits
244
6f6826c5 245i=0
813b4734 246while read commit parents; do
c12764b8 247 i=$(($i+1))
5efb48b5 248 printf "\rRewrite $commit ($i/$commits)"
6f6826c5 249
685ef546
JS
250 case "$filter_subdir" in
251 "")
5be60078 252 git read-tree -i -m $commit
685ef546
JS
253 ;;
254 *)
5be60078 255 git read-tree -i -m $commit:"$filter_subdir"
af580e9c 256 esac || die "Could not initialize the index"
6f6826c5 257
3addc94a
JS
258 GIT_COMMIT=$commit
259 export GIT_COMMIT
af580e9c
JS
260 git cat-file commit "$commit" >../commit ||
261 die "Cannot read commit $commit"
6f6826c5 262
8c1ce0f4
JS
263 eval "$(set_ident AUTHOR <../commit)" ||
264 die "setting author failed for commit $commit"
265 eval "$(set_ident COMMITTER <../commit)" ||
266 die "setting committer failed for commit $commit"
267 eval "$filter_env" < /dev/null ||
268 die "env filter failed: $filter_env"
6f6826c5
JS
269
270 if [ "$filter_tree" ]; then
af580e9c
JS
271 git checkout-index -f -u -a ||
272 die "Could not checkout the index"
6f6826c5
JS
273 # files that $commit removed are now still in the working tree;
274 # remove them, else they would be added again
5be60078 275 git ls-files -z --others | xargs -0 rm -f
8c1ce0f4
JS
276 eval "$filter_tree" < /dev/null ||
277 die "tree filter failed: $filter_tree"
278
1fe32cb9
JH
279 (
280 git diff-index -r --name-only $commit
281 git ls-files --others
282 ) |
283 git update-index --add --replace --remove --stdin
6f6826c5
JS
284 fi
285
8c1ce0f4
JS
286 eval "$filter_index" < /dev/null ||
287 die "index filter failed: $filter_index"
6f6826c5
JS
288
289 parentstr=
813b4734 290 for parent in $parents; do
3520e1e8
JS
291 for reparent in $(map "$parent"); do
292 parentstr="$parentstr -p $reparent"
293 done
6f6826c5
JS
294 done
295 if [ "$filter_parent" ]; then
8c1ce0f4
JS
296 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
297 die "parent filter failed: $filter_parent"
6f6826c5
JS
298 fi
299
300 sed -e '1,/^$/d' <../commit | \
8c1ce0f4
JS
301 eval "$filter_msg" > ../message ||
302 die "msg filter failed: $filter_msg"
303 sh -c "$filter_commit" "git commit-tree" \
304 $(git write-tree) $parentstr < ../message > ../map/$commit
6f6826c5
JS
305done <../revs
306
dfd05e38
JS
307# In case of a subdirectory filter, it is possible that a specified head
308# is not in the set of rewritten commits, because it was pruned by the
309# revision walker. Fix it by mapping these heads to the next rewritten
310# ancestor(s), i.e. the boundaries in the set of rewritten commits.
311
312# NEEDSWORK: we should sort the unmapped refs topologically first
313while read ref
314do
315 sha1=$(git rev-parse "$ref"^0)
316 test -f "$workdir"/../map/$sha1 && continue
317 # Assign the boundarie(s) in the set of rewritten commits
318 # as the replacement commit(s).
319 # (This would look a bit nicer if --not --stdin worked.)
24d00634 320 for p in $( (cd "$workdir"/../map; ls | sed "s/^/^/") |
dfd05e38
JS
321 git rev-list $ref --boundary --stdin |
322 sed -n "s/^-//p")
323 do
324 map $p >> "$workdir"/../map/$sha1
325 done
326done < "$tempdir"/heads
327
328# Finally update the refs
329
330_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
331_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
dfd05e38
JS
332echo
333while read ref
334do
335 # avoid rewriting a ref twice
336 test -f "$orig_namespace$ref" && continue
337
338 sha1=$(git rev-parse "$ref"^0)
339 rewritten=$(map $sha1)
340
341 test $sha1 = "$rewritten" &&
342 warn "WARNING: Ref '$ref' is unchanged" &&
343 continue
344
345 case "$rewritten" in
346 '')
347 echo "Ref '$ref' was deleted"
348 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
349 die "Could not delete $ref"
98409060 350 ;;
dfd05e38
JS
351 $_x40)
352 echo "Ref '$ref' was rewritten"
353 git update-ref -m "filter-branch: rewrite" \
354 "$ref" $rewritten $sha1 ||
355 die "Could not rewrite $ref"
98409060 356 ;;
dfd05e38
JS
357 *)
358 # NEEDSWORK: possibly add -Werror, making this an error
359 warn "WARNING: '$ref' was rewritten into multiple commits:"
360 warn "$rewritten"
361 warn "WARNING: Ref '$ref' points to the first one now."
362 rewritten=$(echo "$rewritten" | head -n 1)
363 git update-ref -m "filter-branch: rewrite to first" \
364 "$ref" $rewritten $sha1 ||
365 die "Could not rewrite $ref"
366 ;;
367 esac
368 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1
dfd05e38
JS
369done < "$tempdir"/heads
370
371# TODO: This should possibly go, with the semantics that all positive given
372# refs are updated, and their original heads stored in refs/original/
373# Filter tags
6f6826c5
JS
374
375if [ "$filter_tag_name" ]; then
5be60078 376 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
6f6826c5
JS
377 while read sha1 type ref; do
378 ref="${ref#refs/tags/}"
379 # XXX: Rewrite tagged trees as well?
380 if [ "$type" != "commit" -a "$type" != "tag" ]; then
381 continue;
382 fi
383
384 if [ "$type" = "tag" ]; then
385 # Dereference to a commit
386 sha1t="$sha1"
5be60078 387 sha1="$(git rev-parse "$sha1"^{commit} 2>/dev/null)" || continue
6f6826c5
JS
388 fi
389
390 [ -f "../map/$sha1" ] || continue
391 new_sha1="$(cat "../map/$sha1")"
3addc94a
JS
392 GIT_COMMIT="$sha1"
393 export GIT_COMMIT
8c1ce0f4
JS
394 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
395 die "tag name filter failed: $filter_tag_name"
6f6826c5
JS
396
397 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
398
399 if [ "$type" = "tag" ]; then
400 # Warn that we are not rewriting the tag object itself.
401 warn "unreferencing tag object $sha1t"
402 fi
403
af580e9c
JS
404 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
405 die "Could not write tag $new_ref"
6f6826c5
JS
406 done
407fi
408
409cd ../..
410rm -rf "$tempdir"
6f6826c5 411
def16e71
BC
412trap - 0
413
46eb449c
JS
414unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
415test -z "$ORIG_GIT_DIR" || GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
416test -z "$ORIG_GIT_WORK_TREE" || GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
417 export GIT_WORK_TREE
418test -z "$ORIG_GIT_INDEX_FILE" || GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
419 export GIT_INDEX_FILE
420git read-tree -u -m HEAD
421
6f6826c5 422exit $ret